# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Terraform.gitlab-ci.yml
  
include:
  - local: '/.gitlab/ci/Terraform/Base.latest.gitlab-ci.yml'
  
terraform:init:
  needs: []
  extends: .terraform:init

terraform:fmt:
  needs: []
  extends: .terraform:fmt

terraform:validate:
  needs: ['terraform:init']
  extends: .terraform:validate

terraform:build:
  needs: ['terraform:validate']
  extends: .terraform:build

terraform:deploy:
  needs: ['terraform:build']
  extends: .terraform:deploy    
  artifacts:
    paths:
      - ops/configuration/inventory
      - dev/ui/src/environments/environment.prod.ts
    reports:
      dotenv: deploy.env
  environment:
    name: $TF_STATE_NAME
    url: $DYNAMIC_ENVIRONMENT_URL
    action: prepare

terraform:destroy:
  needs:
    - job: 'all:deploy'
      optional: true
    - job: 'ansible:playbook'
      optional: false
  extends: .terraform:destroy
  when: manual
  environment:
    name: production
    url: http://$DYNAMIC_ENVIRONMENT_URL
    action: stop

